// palaxKeyGenDlg.cpp : implementation file
//

#include "stdafx.h"
#include "palaxKeyGen.h"
#include "palaxKeyGenDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif


extern "C" {

#include <miracl.h>


void SHA1_Init(char  *);
void SHA1_Process(char  *, char *, int );
void SHA1_Final(char  *);

}


/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPalaxKeyGenDlg dialog

CPalaxKeyGenDlg::CPalaxKeyGenDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CPalaxKeyGenDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CPalaxKeyGenDlg)
	m_strKey = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CPalaxKeyGenDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPalaxKeyGenDlg)
	DDX_Text(pDX, IDC_EDIT_KEY, m_strKey);
	DDV_MaxChars(pDX, m_strKey, 1024);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CPalaxKeyGenDlg, CDialog)
	//{{AFX_MSG_MAP(CPalaxKeyGenDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON1, OnButtonGenerateKey)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPalaxKeyGenDlg message handlers

BOOL CPalaxKeyGenDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CPalaxKeyGenDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CPalaxKeyGenDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CPalaxKeyGenDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CPalaxKeyGenDlg::OnOK() 
{


}

void CPalaxKeyGenDlg::OnCancel() 
{
	
	CDialog::OnCancel();
}


void hash(char *buffer, int length, char *hash)
{

	char temp[128];
	SHA1_Init(temp);
	SHA1_Process(temp,buffer,length);
	SHA1_Final(temp);
	memcpy(hash,temp+0x40,20);

}


void CPalaxKeyGenDlg::OnButtonGenerateKey() 
{


	unsigned char digest[32]={0}, serialnumber[512]={0};
	unsigned long VolumeSerialNumber=0;
	char strVolume[16]={0};
	miracl *mip;
	big modulus, private_key, msg, exp, cyphered;

	GetVolumeInformation(0,0,0,&VolumeSerialNumber,0,0,0,0);
	sprintf(strVolume,"%x",VolumeSerialNumber);
	hash((char*)strVolume,strlen((char*)strVolume),(char*)digest);

	
	mip=mirsys(0x64,0);
	mip->IOBASE=16;
	modulus=mirvar(0);
	private_key=mirvar(0);
	msg=mirvar(0);
	cyphered=mirvar(0);
	exp=mirvar(0);
	
	cinstr(modulus,"6601E15E4F6C572B0B38EDF792D426BBA6DEDB98D600C5763C5F2123A361F49C0CAEA628887077DE01D1DE826D2496DF38802024BC00A64940C8EAB4F1D860443C8DE0CEB6B7611888F660B022AA32C3450BC2B6E035D6354654E8EF466631F0D180E978DB6960EB4061EAB52D0B281C580B8DA8FE76AB54D5AD85223DBE1449");
	cinstr(private_key,"B33F");
	cinstr(exp,"920CC8F0512FB63B8C2F89397A129BAA3D663BD1890C8EE23AAC836A316E231B");
	
	bytes_to_big(8,(char*)digest,msg);
	power(msg,7,exp,msg);
	powmod(msg,private_key,modulus,cyphered);

	cotstr(cyphered,(char*)serialnumber);

	this->m_strKey.Format("%s",serialnumber);
	
	UpdateData(FALSE);
//	printf("%s\n",serialnumber);
	mirkill(cyphered);
	mirkill(msg);
	mirkill(private_key);
	mirkill(modulus);
	mirkill(exp);

	
}
