.386
locals
jumps
.model flat,STDCALL


.code

start:
PUBLIC _SHA1_Init
_SHA1_Init proc near

arg_0= dword ptr  4


mov	eax, [esp+arg_0]
and	dword ptr [eax+54h], 0
and	dword ptr [eax+58h], 0
mov	dword ptr [eax+40h], 67452301h
mov	dword ptr [eax+44h], 0EFCDAB89h
mov	dword ptr [eax+48h], 98BADCFEh
mov	dword ptr [eax+4Ch], 10325476h
mov	dword ptr [eax+50h], 0C3D2E1F0h
retn


_SHA1_Init endp

PUBLIC	_my_memcpy
_my_memcpy proc near

arg_0= dword ptr  8
arg_4= dword ptr  0Ch
arg_8= dword ptr  10h

push	ebp
mov	ebp, esp

push ecx
push edi
push esi
cld
mov ecx, [ebp+arg_8]
mov edi, [ebp+arg_0]
mov esi, [ebp+arg_4]
rep movsb
pop esi
pop edi
pop ecx

pop ebp
retn

_my_memcpy endp

PUBLIC _my_memset
_my_memset proc near

arg_0= dword ptr  8
arg_4= dword ptr  0Ch
arg_8= dword ptr  10h

push	ebp
mov	ebp, esp


push ecx
push edi
push eax
cld
mov ecx, [ebp+arg_8]
mov edi, [ebp+arg_0]
xor eax, eax
mov al,  byte ptr [ebp+arg_4]
rep stosb
pop eax
pop edi
pop ecx

pop ebp
retn

_my_memset endp
; Attributes: bp-based frame

; int __cdecl _SHA1_Process(int,void *,int)
PUBLIC _SHA1_Process
_SHA1_Process proc near

arg_0= dword ptr  8
arg_4= dword ptr  0Ch
arg_8= dword ptr  10h

push	ebp
mov	ebp, esp
push	ebx
mov	ebx, [ebp+arg_8]
push	esi
mov	esi, [ebp+arg_0]
mov	eax, [esi+58h]
lea	ecx, [eax+ebx*8]
cmp	ecx, eax
push	edi
mov	[esi+58h], ecx
jnb	short loc_4023C0
inc	dword ptr [esi+54h]

loc_4023C0:
mov	ecx, ebx
shr	ecx, 1Dh
add	[esi+54h], ecx
shr	eax, 3
and	eax, 3Fh
jz	short loc_4023FB
push	40h
pop	edi
sub	edi, eax
cmp	ebx, edi
lea	ecx, [eax+esi]
jnb	short loc_4023E3
push	ebx
push	[ebp+arg_4]
push	ecx
jmp	short loc_402428

loc_4023E3:		; size_t
push	edi
push	[ebp+arg_4]	; void *
push	ecx		; void *
call	_my_memcpy
push	esi
call	_SHA1
add	[ebp+arg_4], edi
add	esp, 10h
sub	ebx, edi

loc_4023FB:
cmp	ebx, 40h
jb	short loc_402423
mov	edi, ebx
shr	edi, 6

loc_402405:		; size_t
push	40h
push	[ebp+arg_4]	; void *
push	esi		; void *
call	_my_memcpy
push	esi
call	_SHA1
add	[ebp+arg_4], 40h
add	esp, 10h
sub	ebx, 40h
dec	edi
jnz	short loc_402405

loc_402423:		; size_t
push	ebx
push	[ebp+arg_4]	; void *
push	esi		; void *

loc_402428:
call	_my_memcpy
add	esp, 0Ch
pop	edi
pop	esi
pop	ebx
pop	ebp
retn
_SHA1_Process endp



PUBLIC _SHA1_Final
_SHA1_Final proc	near

arg_0= dword ptr  8

push	esi
mov	esi, [esp+arg_0]
mov	eax, [esi+58h]
sar	eax, 3
push	3Fh
pop	ecx
and	eax, ecx
lea	edx, [eax+esi]
mov	byte ptr [edx],	80h
sub	ecx, eax
inc	edx
cmp	ecx, 8
jge	short loc_402471
push	ecx		; size_t
push	0		; int
push	edx		; void *
call	_my_memset
push	esi
call	_SHA1
push	38h		; size_t
push	0		; int
push	esi		; void *
call	_my_memset
add	esp, 1Ch
jmp	short loc_402480

loc_402471:
add	ecx, 0FFFFFFF8h
push	ecx		; size_t
push	0		; int
push	edx		; void *
call	_my_memset
add	esp, 0Ch

loc_402480:
mov	eax, [esi+54h]
mov	[esi+38h], eax
mov	eax, [esi+58h]
push	esi
mov	[esi+3Ch], eax
call	_SHA1
pop	ecx
pop	esi
retn
_SHA1_Final endp


; Attributes: bp-based frame
PUBLIC _SHA1
_SHA1 proc near

var_10=	dword ptr -10h
var_C= dword ptr -0Ch
var_8= dword ptr -8
var_4= dword ptr -4
arg_0= dword ptr  8

push	ebp
mov	ebp, esp
sub	esp, 10h
mov	eax, [ebp+arg_0]
mov	ecx, [eax+4Ch]	; take H3
push	ebx
push	esi
mov	esi, [eax+40h]	; take H0
push	edi
mov	edi, [eax+44h]	; take H1
mov	edx, esi
mov	ebx, esi
shl	ebx, 5		; << n
shr	edx, 1Bh	; >> (32-n)
or	edx, ebx
add	edx, [eax]
mov	ebx, ecx
xor	ebx, [eax+48h]
and	ebx, edi
xor	ebx, ecx
mov	ecx, [eax+50h]
add	ebx, edx
lea	ecx, [ebx+ecx+5A827999h]
mov	edx, edi
shr	edi, 2
mov	ebx, ecx
shl	ebx, 5
shl	edx, 1Eh
or	edx, edi
mov	edi, ecx
shr	edi, 1Bh
or	edi, ebx
mov	ebx, [eax+48h]
xor	ebx, edx
and	ebx, esi
xor	ebx, [eax+48h]
mov	esi, [eax+4Ch]
add	edi, ebx
add	edi, [eax+4]
lea	ebx, [esi+edi+5A827999h]
mov	edi, [eax+40h]
mov	esi, edi
shr	edi, 2
mov	[ebp+var_4], ebx
shl	esi, 1Eh
or	esi, edi
mov	edi, ebx
shr	edi, 1Bh
shl	ebx, 5
or	edi, ebx
add	edi, [eax+8]
mov	ebx, edx
xor	ebx, esi
and	ebx, ecx
xor	ebx, edx
add	ebx, edi
mov	edi, ecx
shr	ecx, 2
shl	edi, 1Eh
or	edi, ecx
mov	[ebp+var_8], edi
mov	[ebp+arg_0], esi
xor	edi, [ebp+arg_0]
mov	esi, [eax+48h]
and	edi, [ebp+var_4]
lea	esi, [esi+ebx+5A827999h]
xor	edi, [ebp+arg_0]
mov	ecx, esi
shr	ecx, 1Bh
mov	ebx, esi
shl	ebx, 5
or	ecx, ebx
add	ecx, edi
add	ecx, [eax+0Ch]
mov	edi, [ebp+var_4]
lea	edx, [edx+ecx+5A827999h]
mov	ecx, edi
shr	edi, 2
shl	ecx, 1Eh
or	ecx, edi
mov	edi, edx
mov	[ebp+var_4], ecx
shr	edi, 1Bh
mov	ebx, edx
shl	ebx, 5
or	edi, ebx
mov	ebx, [ebp+var_8]
xor	ebx, ecx
and	ebx, esi
xor	ebx, [ebp+var_8]
mov	ecx, [ebp+arg_0]
add	edi, ebx
add	edi, [eax+10h]
lea	ecx, [ecx+edi+5A827999h]
mov	edi, esi
shl	edi, 1Eh
shr	esi, 2
or	edi, esi
mov	esi, ecx
shr	esi, 1Bh
mov	ebx, ecx
shl	ebx, 5
or	esi, ebx
mov	ebx, [ebp+var_4]
xor	ebx, edi
and	ebx, edx
xor	ebx, [ebp+var_4]
mov	[ebp+var_10], edi
mov	edi, [ebp+var_8]
add	esi, ebx
add	esi, [eax+14h]
lea	esi, [edi+esi+5A827999h]
mov	edi, edx
shl	edi, 1Eh
shr	edx, 2
or	edi, edx
mov	edx, esi
mov	ebx, esi
shl	ebx, 5
shr	edx, 1Bh
or	edx, ebx
mov	ebx, [ebp+var_10]
xor	ebx, edi
and	ebx, ecx
xor	ebx, [ebp+var_10]
mov	[ebp+var_C], edi
mov	edi, [ebp+var_4]
add	edx, ebx
add	edx, [eax+18h]
lea	edx, [edi+edx+5A827999h]
mov	edi, ecx
shl	edi, 1Eh
shr	ecx, 2
or	edi, ecx
mov	ecx, edx
shr	ecx, 1Bh
mov	ebx, edx
shl	ebx, 5
or	ecx, ebx
mov	ebx, [ebp+var_C]
xor	ebx, edi
and	ebx, esi
xor	ebx, [ebp+var_C]
mov	[ebp+arg_0], edi
mov	edi, [ebp+var_10]
add	ecx, ebx
add	ecx, [eax+1Ch]
lea	ecx, [edi+ecx+5A827999h]
mov	edi, esi
shr	esi, 2
shl	edi, 1Eh
or	edi, esi
mov	[ebp+var_8], edi
xor	edi, [ebp+arg_0]
mov	esi, ecx
shr	esi, 1Bh
mov	ebx, ecx
shl	ebx, 5
or	esi, ebx
add	esi, [eax+20h]
and	edi, edx
xor	edi, [ebp+arg_0]
add	edi, esi
mov	esi, [ebp+var_C]
lea	esi, [esi+edi+5A827999h]
mov	edi, edx
shl	edi, 1Eh
shr	edx, 2
or	edi, edx
mov	edx, esi
shr	edx, 1Bh
mov	ebx, esi
shl	ebx, 5
or	edx, ebx
mov	ebx, [ebp+var_8]
xor	ebx, edi
and	ebx, ecx
xor	ebx, [ebp+var_8]
mov	[ebp+var_4], edi
mov	edi, [ebp+arg_0]
add	edx, ebx
add	edx, [eax+24h]
lea	edx, [edi+edx+5A827999h]
mov	edi, ecx
shl	edi, 1Eh
shr	ecx, 2
or	edi, ecx
mov	ecx, edx
mov	ebx, edx
shl	ebx, 5
shr	ecx, 1Bh
or	ecx, ebx
mov	ebx, [ebp+var_4]
xor	ebx, edi
and	ebx, esi
xor	ebx, [ebp+var_4]
mov	[ebp+var_10], edi
mov	edi, [ebp+var_8]
add	ecx, ebx
add	ecx, [eax+28h]
lea	ecx, [edi+ecx+5A827999h]
mov	edi, esi
shl	edi, 1Eh
shr	esi, 2
or	edi, esi
mov	esi, ecx
shr	esi, 1Bh
mov	ebx, ecx
shl	ebx, 5
or	esi, ebx
mov	ebx, [ebp+var_10]
xor	ebx, edi
and	ebx, edx
xor	ebx, [ebp+var_10]
mov	[ebp+var_C], edi
mov	edi, [ebp+var_4]
add	esi, ebx
add	esi, [eax+2Ch]
lea	esi, [edi+esi+5A827999h]
mov	edi, edx
shr	edx, 2
shl	edi, 1Eh
or	edi, edx
mov	edx, esi
shr	edx, 1Bh
mov	ebx, esi
shl	ebx, 5
or	edx, ebx
mov	ebx, [ebp+var_C]
xor	ebx, edi
and	ebx, ecx
xor	ebx, [ebp+var_C]
mov	[ebp+arg_0], edi
mov	edi, [ebp+var_10]
add	edx, ebx
add	edx, [eax+30h]
lea	edx, [edi+edx+5A827999h]
mov	edi, ecx
shr	ecx, 2
shl	edi, 1Eh
or	edi, ecx
mov	ecx, [eax+34h]
mov	ebx, edx
mov	[ebp+var_8], edi
mov	[ebp+var_10], ecx
shr	ebx, 1Bh
xor	edi, [ebp+arg_0]
mov	ecx, edx
and	edi, esi
xor	edi, [ebp+arg_0]
shl	ecx, 5
or	ebx, ecx
mov	ecx, [ebp+var_10]
add	ebx, ecx
add	edi, ebx
mov	ebx, [ebp+var_C]
lea	ebx, [ebx+edi+5A827999h]
mov	[ebp+var_C], ebx
mov	edi, esi
shl	edi, 1Eh
shr	esi, 2
or	edi, esi
mov	esi, ebx
shl	ebx, 5
shr	esi, 1Bh
or	esi, ebx
mov	ebx, [ebp+var_8]
xor	ebx, edi
and	ebx, edx
xor	ebx, [ebp+var_8]
xor	ecx, [eax+20h]
add	esi, ebx
add	esi, [eax+38h]
mov	[ebp+var_4], edi
mov	edi, [ebp+arg_0]
xor	ecx, [eax+8]
lea	esi, [edi+esi+5A827999h]
xor	ecx, [eax]
mov	edi, edx
shl	edi, 1Eh
shr	edx, 2
or	edi, edx
mov	edx, esi
shr	edx, 1Bh
mov	ebx, esi
shl	ebx, 5
or	edx, ebx
mov	ebx, [ebp+var_4]
xor	ebx, edi
and	ebx, [ebp+var_C]
mov	[ebp+var_10], edi
xor	ebx, [ebp+var_4]
mov	edi, [ebp+var_8]
add	edx, ebx
add	edx, [eax+3Ch]
mov	ebx, [ebp+var_C]
lea	edx, [edi+edx+5A827999h]
mov	edi, ebx
shr	ebx, 2
mov	[ebp+arg_0], ecx
mov	[eax], ecx
shl	edi, 1Eh
or	edi, ebx
mov	ecx, edx
shr	ecx, 1Bh
mov	ebx, edx
shl	ebx, 5
or	ecx, ebx
mov	ebx, [ebp+var_10]
add	ecx, [ebp+arg_0]
xor	ebx, edi
and	ebx, esi
xor	ebx, [ebp+var_10]
mov	[ebp+var_C], edi
add	ebx, ecx
mov	ecx, [ebp+var_4]
lea	ebx, [ecx+ebx+5A827999h]
mov	ecx, [eax+24h]
xor	ecx, [eax+0Ch]
mov	edi, esi
xor	ecx, [eax+4]
shl	edi, 1Eh
shr	esi, 2
or	edi, esi
xor	ecx, [eax+38h]
mov	[ebp+var_4], ebx
mov	[ebp+arg_0], edi
mov	esi, ebx
shl	ebx, 5
shr	esi, 1Bh
or	esi, ebx
mov	ebx, [ebp+var_C]
xor	ebx, edi
add	esi, ecx
and	ebx, edx
xor	ebx, [ebp+var_C]
mov	[eax+4], ecx
mov	ecx, [ebp+var_10]
add	ebx, esi
lea	esi, [ecx+ebx+5A827999h]
mov	ecx, [eax+3Ch]
xor	ecx, [eax+10h]
mov	edi, edx
xor	ecx, [eax+8]
shl	edi, 1Eh
xor	ecx, [eax+28h]
shr	edx, 2
or	edi, edx
mov	[ebp+var_8], edi
xor	edi, [ebp+arg_0]
mov	edx, esi
and	edi, [ebp+var_4]
mov	ebx, esi
xor	edi, [ebp+arg_0]
shl	ebx, 5
mov	[eax+8], ecx
shr	edx, 1Bh
or	edx, ebx
add	edx, ecx
mov	ecx, [ebp+var_C]
add	edi, edx
lea	edi, [ecx+edi+5A827999h]
mov	ecx, [ebp+var_4]
mov	edx, ecx
shr	ecx, 2
mov	ebx, edi
mov	[ebp+var_C], edi
shl	edi, 5
shl	edx, 1Eh
or	edx, ecx
mov	ecx, [eax+2Ch]
xor	ecx, [eax+14h]
shr	ebx, 1Bh
xor	ecx, [eax+0Ch]
or	ebx, edi
xor	ecx, [eax]
mov	edi, [ebp+var_8]
xor	edi, edx
and	edi, esi
xor	edi, [ebp+var_8]
add	ebx, ecx
add	edi, ebx
mov	[eax+0Ch], ecx
mov	ecx, [ebp+arg_0]
mov	[ebp+var_4], edx
lea	edx, [ecx+edi+5A827999h]
mov	ecx, [eax+10h]
xor	ecx, [eax+4]
mov	edi, esi
xor	ecx, [eax+30h]
shr	esi, 2
xor	ecx, [eax+18h]
shl	edi, 1Eh
or	edi, esi
mov	ebx, edx
mov	esi, edx
shl	esi, 5
shr	ebx, 1Bh
or	ebx, esi
mov	esi, [ebp+var_4]
xor	esi, edi
mov	[ebp+arg_0], esi
mov	esi, [ebp+var_C]
mov	[ebp+var_10], edi
mov	edi, [ebp+arg_0]
xor	edi, esi
mov	[eax+10h], ecx
add	ebx, ecx
mov	ecx, [ebp+var_8]
add	edi, ebx
lea	ebx, [ecx+edi+6ED9EBA1h]
mov	ecx, [eax+34h]
xor	ecx, [eax+1Ch]
mov	edi, esi
xor	ecx, [eax+14h]
mov	[ebp+var_8], ebx
xor	ecx, [eax+8]
shr	esi, 2
shl	edi, 1Eh
or	edi, esi
mov	esi, ebx
shl	ebx, 5
mov	[eax+14h], ecx
shr	esi, 1Bh
or	esi, ebx
mov	ebx, [ebp+var_10]
add	esi, ecx
mov	ecx, [ebp+var_4]
xor	ebx, edi
xor	ebx, edx
add	ebx, esi
lea	esi, [ecx+ebx+6ED9EBA1h]
mov	ecx, edx
shl	ecx, 1Eh
shr	edx, 2
or	ecx, edx
mov	[ebp+arg_0], ecx
mov	ecx, [eax+0Ch]
xor	ecx, [eax+38h]
mov	edx, esi
xor	ecx, [eax+20h]
shr	edx, 1Bh
xor	[eax+18h], ecx
mov	ecx, esi
shl	ecx, 5
or	edx, ecx
mov	ecx, [ebp+var_8]
add	edx, [eax+18h]
mov	ebx, ecx
xor	ebx, edi
xor	ebx, [ebp+arg_0]
mov	[ebp+var_C], edi
mov	edi, ecx
add	ebx, edx
mov	edx, [ebp+var_10]
shr	ecx, 2
shl	edi, 1Eh
or	edi, ecx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+24h]
lea	edx, [edx+ebx+6ED9EBA1h]
xor	ecx, [eax+1Ch]
mov	[ebp+var_8], edi
xor	ecx, [eax+10h]
mov	edi, edx
shr	edi, 1Bh
mov	ebx, edx
shl	ebx, 5
or	edi, ebx
mov	ebx, [ebp+var_8]
xor	ebx, esi
xor	ebx, [ebp+arg_0]
add	edi, ecx
mov	[eax+1Ch], ecx
mov	ecx, [ebp+var_C]
add	ebx, edi
lea	edi, [ecx+ebx+6ED9EBA1h]
mov	ecx, esi
shr	esi, 2
shl	ecx, 1Eh
or	ecx, esi
mov	esi, [eax+14h]
xor	esi, [eax]
mov	[ebp+var_4], ecx
xor	esi, [eax+28h]
mov	ebx, edi
xor	[eax+20h], esi
mov	esi, edi
shr	esi, 1Bh
shl	ebx, 5
or	esi, ebx
add	esi, [eax+20h]
mov	ebx, [ebp+var_8]
xor	ebx, ecx
mov	ecx, [ebp+arg_0]
xor	ebx, edx
add	ebx, esi
lea	ebx, [ecx+ebx+6ED9EBA1h]
mov	ecx, [eax+2Ch]
xor	ecx, [eax+24h]
mov	esi, edx
xor	ecx, [eax+4]
shl	esi, 1Eh
xor	ecx, [eax+18h]
shr	edx, 2
or	esi, edx
mov	[ebp+arg_0], ebx
mov	[eax+24h], ecx
mov	edx, ebx
shl	ebx, 5
shr	edx, 1Bh
or	edx, ebx
mov	ebx, [ebp+var_4]
add	edx, ecx
mov	ecx, [ebp+var_8]
xor	ebx, esi
xor	ebx, edi
add	ebx, edx
lea	edx, [ecx+ebx+6ED9EBA1h]
mov	ecx, [eax+1Ch]
xor	ecx, [eax+8]
mov	ebx, edi
xor	ecx, [eax+30h]
shr	edi, 2
xor	[eax+28h], ecx
mov	[ebp+var_10], esi
shl	ebx, 1Eh
or	ebx, edi
xor	esi, ebx
xor	esi, [ebp+arg_0]
mov	ecx, edx
shr	ecx, 1Bh
mov	edi, edx
shl	edi, 5
or	ecx, edi
add	ecx, [eax+28h]
mov	[ebp+var_C], ebx
add	esi, ecx
mov	ecx, [ebp+var_4]
lea	edi, [ecx+esi+6ED9EBA1h]
mov	ecx, [ebp+arg_0]
mov	esi, ecx
shr	ecx, 2
shl	esi, 1Eh
or	esi, ecx
mov	ecx, [eax+34h]
xor	ecx, [eax+2Ch]
mov	[ebp+arg_0], esi
xor	ecx, [eax+0Ch]
mov	esi, edi
xor	ecx, [eax+20h]
mov	[ebp+var_4], edi
shl	edi, 5
shr	esi, 1Bh
or	esi, edi
mov	edi, edx
add	esi, ecx
xor	edi, ebx
xor	edi, [ebp+arg_0]
mov	[eax+2Ch], ecx
mov	ecx, [ebp+var_10]
add	edi, esi
lea	esi, [ecx+edi+6ED9EBA1h]
mov	ecx, edx
shr	edx, 2
shl	ecx, 1Eh
or	ecx, edx
mov	edx, [eax+24h]
xor	edx, [eax+10h]
mov	[ebp+var_8], ecx
xor	edx, [eax+38h]
mov	edi, esi
xor	[eax+30h], edx
mov	edx, [eax+30h]
shr	edi, 1Bh
mov	ebx, esi
shl	ebx, 5
or	edi, ebx
mov	ebx, ecx
mov	ecx, [ebp+var_4]
xor	ebx, ecx
xor	ebx, [ebp+arg_0]
add	edi, edx
add	ebx, edi
mov	edx, [ebp+var_C]
mov	edi, ecx
shr	ecx, 2
lea	edx, [edx+ebx+6ED9EBA1h]
shl	edi, 1Eh
or	edi, ecx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+34h]
mov	[ebp+var_4], edi
xor	ecx, [eax+14h]
mov	edi, edx
xor	ecx, [eax+28h]
shr	edi, 1Bh
mov	ebx, edx
shl	ebx, 5
or	edi, ebx
mov	ebx, [ebp+var_8]
xor	ebx, [ebp+var_4]
add	edi, ecx
xor	ebx, esi
add	ebx, edi
mov	[eax+34h], ecx
mov	ecx, [ebp+arg_0]
lea	ebx, [ecx+ebx+6ED9EBA1h]
mov	ecx, [eax+2Ch]
xor	ecx, [eax]
mov	edi, esi
xor	ecx, [eax+38h]
shr	esi, 2
xor	ecx, [eax+18h]
mov	[ebp+arg_0], ebx
shl	edi, 1Eh
or	edi, esi
mov	esi, ebx
shl	ebx, 5
shr	esi, 1Bh
or	esi, ebx
mov	ebx, [ebp+var_4]
add	esi, ecx
xor	ebx, edi
xor	ebx, edx
mov	[eax+38h], ecx
mov	ecx, [ebp+var_8]
add	ebx, esi
lea	esi, [ecx+ebx+6ED9EBA1h]
mov	ecx, edx
shl	ecx, 1Eh
shr	edx, 2
or	ecx, edx
mov	[ebp+var_C], ecx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+1Ch]
mov	ebx, esi
xor	ecx, [eax+4]
shr	ebx, 1Bh
xor	ecx, [eax+30h]
mov	edx, esi
shl	edx, 5
mov	[ebp+var_10], edi
xor	edi, [ebp+var_C]
or	ebx, edx
mov	edx, [ebp+arg_0]
add	ebx, ecx
xor	edi, edx
mov	[eax+3Ch], ecx
mov	ecx, [ebp+var_4]
add	edi, ebx
lea	edi, [ecx+edi+6ED9EBA1h]
mov	ecx, edx
shl	ecx, 1Eh
mov	[ebp+var_4], edi
shr	edx, 2
or	ecx, edx
mov	[ebp+arg_0], ecx
mov	ecx, [eax+34h]
xor	ecx, [eax+8]
mov	edx, edi
xor	ecx, [eax]
shl	edi, 5
xor	ecx, [eax+20h]
shr	edx, 1Bh
or	edx, edi
add	edx, ecx
mov	[eax], ecx
mov	ecx, [ebp+var_10]
mov	edi, esi
xor	edi, [ebp+var_C]
xor	edi, [ebp+arg_0]
add	edi, edx
lea	edx, [ecx+edi+6ED9EBA1h]
mov	ecx, [eax+24h]
xor	ecx, [eax+0Ch]
mov	edi, esi
xor	ecx, [eax+4]
shr	esi, 2
xor	ecx, [eax+38h]
shl	edi, 1Eh
or	edi, esi
mov	[eax+4], ecx
mov	[ebp+var_8], edi
xor	edi, [ebp+var_4]
mov	esi, edx
xor	edi, [ebp+arg_0]
shr	esi, 1Bh
mov	ebx, edx
shl	ebx, 5
or	esi, ebx
add	esi, ecx
mov	ecx, [ebp+var_C]
add	edi, esi
lea	esi, [ecx+edi+6ED9EBA1h]
mov	ecx, [ebp+var_4]
mov	edi, ecx
shr	ecx, 2
shl	edi, 1Eh
or	edi, ecx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+10h]
mov	ebx, esi
xor	ecx, [eax+8]
mov	[ebp+var_C], esi
xor	ecx, [eax+28h]
shl	esi, 5
shr	ebx, 1Bh
or	ebx, esi
mov	esi, [ebp+var_8]
add	ebx, ecx
mov	[eax+8], ecx
mov	ecx, [ebp+arg_0]
xor	esi, edi
xor	esi, edx
add	esi, ebx
lea	esi, [ecx+esi+6ED9EBA1h]
mov	ecx, edx
shl	ecx, 1Eh
shr	edx, 2
or	ecx, edx
mov	[ebp+var_10], ecx
mov	ecx, [eax+2Ch]
xor	ecx, [eax+14h]
mov	edx, esi
xor	ecx, [eax+0Ch]
mov	ebx, esi
xor	ecx, [eax]
shr	edx, 1Bh
mov	[ebp+var_4], edi
mov	[eax+0Ch], ecx
shl	ebx, 5
or	edx, ebx
add	edx, ecx
mov	ecx, [ebp+var_8]
mov	ebx, edi
xor	ebx, [ebp+var_10]
mov	edi, [ebp+var_C]
xor	ebx, edi
add	ebx, edx
lea	ebx, [ecx+ebx+6ED9EBA1h]
mov	ecx, [eax+10h]
xor	ecx, [eax+4]
mov	[ebp+var_8], ebx
xor	ecx, [eax+30h]
mov	edx, edi
xor	ecx, [eax+18h]
shl	edx, 1Eh
shr	edi, 2
or	edx, edi
mov	edi, ebx
shl	ebx, 5
mov	[eax+10h], ecx
shr	edi, 1Bh
or	edi, ebx
mov	ebx, [ebp+var_10]
xor	ebx, edx
add	edi, ecx
mov	ecx, [ebp+var_4]
xor	ebx, esi
add	ebx, edi
lea	edi, [ecx+ebx+6ED9EBA1h]
mov	ecx, esi
shl	ecx, 1Eh
shr	esi, 2
or	ecx, esi
mov	[ebp+arg_0], ecx
mov	ecx, [eax+34h]
xor	ecx, [eax+1Ch]
mov	esi, edi
xor	ecx, [eax+14h]
shr	esi, 1Bh
xor	ecx, [eax+8]
mov	ebx, edi
shl	ebx, 5
or	esi, ebx
mov	ebx, [ebp+var_8]
xor	ebx, edx
xor	ebx, [ebp+arg_0]
add	esi, ecx
mov	[eax+14h], ecx
mov	ecx, [ebp+var_10]
add	ebx, esi
mov	[ebp+var_C], edx
lea	edx, [ecx+ebx+6ED9EBA1h]
mov	ecx, [ebp+var_8]
mov	esi, ecx
shr	ecx, 2
mov	ebx, edx
shl	esi, 1Eh
or	esi, ecx
mov	ecx, [eax+0Ch]
xor	ecx, [eax+38h]
mov	[ebp+var_10], edx
xor	ecx, [eax+20h]
shl	edx, 5
xor	[eax+18h], ecx
mov	ecx, [eax+18h]
shr	ebx, 1Bh
or	ebx, edx
mov	edx, esi
xor	edx, edi
xor	edx, [ebp+arg_0]
add	ebx, ecx
mov	ecx, [ebp+var_C]
add	edx, ebx
lea	edx, [ecx+edx+6ED9EBA1h]
mov	ecx, edi
shl	ecx, 1Eh
shr	edi, 2
or	ecx, edi
mov	[ebp+var_8], esi
mov	[ebp+var_4], ecx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+24h]
xor	esi, [ebp+var_4]
xor	ecx, [eax+1Ch]
mov	ebx, edx
xor	ecx, [eax+10h]
mov	edi, edx
shl	edi, 5
mov	[eax+1Ch], ecx
shr	ebx, 1Bh
or	ebx, edi
mov	edi, [ebp+var_10]
xor	esi, edi
add	ebx, ecx
mov	ecx, [ebp+arg_0]
add	esi, ebx
lea	esi, [ecx+esi+6ED9EBA1h]
mov	ecx, edi
shr	edi, 2
shl	ecx, 1Eh
or	ecx, edi
mov	edi, [eax+14h]
xor	edi, [eax]
mov	[ebp+var_10], ecx
xor	edi, [eax+28h]
mov	ebx, esi
xor	[eax+20h], edi
mov	edi, ecx
or	edi, edx
and	edi, [ebp+var_4]
and	ecx, edx
or	edi, ecx
add	edi, [eax+20h]
mov	ecx, esi
shr	ecx, 1Bh
shl	ebx, 5
or	ecx, ebx
add	ecx, edi
mov	edi, [ebp+var_8]
lea	ebx, [edi+ecx-70E44324h]
mov	ecx, [eax+2Ch]
xor	ecx, [eax+24h]
mov	edi, edx
xor	ecx, [eax+4]
shl	edi, 1Eh
xor	ecx, [eax+18h]
shr	edx, 2
or	edi, edx
mov	edx, edi
or	edx, esi
and	edx, [ebp+var_10]
mov	[ebp+var_C], edi
and	edi, esi
or	edx, edi
add	edx, ecx
mov	[eax+24h], ecx
mov	ecx, [ebp+var_4]
mov	[ebp+var_8], ebx
mov	edi, ebx
shr	edi, 1Bh
shl	ebx, 5
or	edi, ebx
add	edi, edx
lea	edx, [ecx+edi-70E44324h]
mov	ecx, [eax+1Ch]
xor	ecx, [eax+8]
mov	edi, esi
xor	ecx, [eax+30h]
shr	esi, 2
xor	[eax+28h], ecx
mov	ecx, [ebp+var_8]
shl	edi, 1Eh
or	edi, esi
mov	esi, [ebp+var_8]
or	ecx, edi
and	ecx, [ebp+var_C]
and	esi, edi
or	ecx, esi
mov	esi, edx
mov	[ebp+arg_0], edi
shr	esi, 1Bh
add	ecx, [eax+28h]
mov	ebx, edx
shl	ebx, 5
or	esi, ebx
add	esi, ecx
mov	ecx, [ebp+var_10]
lea	ecx, [ecx+esi-70E44324h]
mov	[ebp+var_10], ecx
mov	ecx, [ebp+var_8]
mov	esi, ecx
shr	ecx, 2
shl	esi, 1Eh
or	esi, ecx
mov	ecx, [eax+34h]
xor	ecx, [eax+2Ch]
mov	ebx, esi
xor	ecx, [eax+0Ch]
or	ebx, edx
xor	ecx, [eax+20h]
and	ebx, edi
mov	edi, [ebp+var_10]
mov	[eax+2Ch], ecx
mov	[ebp+var_8], esi
and	esi, edx
or	ebx, esi
mov	esi, [ebp+var_10]
add	ebx, ecx
mov	ecx, [ebp+var_C]
shl	edi, 5
shr	esi, 1Bh
or	esi, edi
mov	edi, edx
add	esi, ebx
lea	esi, [ecx+esi-70E44324h]
mov	ecx, [eax+24h]
xor	ecx, [eax+10h]
shr	edx, 2
xor	ecx, [eax+38h]
shl	edi, 1Eh
xor	[eax+30h], ecx
or	edi, edx
mov	ecx, edi
or	ecx, [ebp+var_10]
mov	edx, edi
and	edx, [ebp+var_10]
and	ecx, [ebp+var_8]
mov	ebx, esi
or	ecx, edx
add	ecx, [eax+30h]
shl	ebx, 5
mov	edx, esi
shr	edx, 1Bh
or	edx, ebx
add	edx, ecx
mov	ecx, [ebp+arg_0]
lea	ecx, [ecx+edx-70E44324h]
mov	[ebp+arg_0], ecx
mov	ecx, [ebp+var_10]
mov	edx, ecx
shl	edx, 1Eh
shr	ecx, 2
or	edx, ecx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+34h]
mov	ebx, edx
xor	ecx, [eax+14h]
mov	[ebp+var_10], edx
xor	ecx, [eax+28h]
or	ebx, esi
and	ebx, edi
and	edx, esi
or	ebx, edx
mov	edx, [ebp+arg_0]
mov	[ebp+var_4], edi
mov	edi, [ebp+arg_0]
shr	edx, 1Bh
shl	edi, 5
or	edx, edi
add	ebx, ecx
mov	[eax+34h], ecx
add	edx, ebx
mov	ecx, [ebp+var_8]
lea	edx, [ecx+edx-70E44324h]
mov	ecx, [eax+2Ch]
xor	ecx, [eax]
mov	edi, esi
xor	ecx, [eax+38h]
shl	edi, 1Eh
xor	ecx, [eax+18h]
shr	esi, 2
or	edi, esi
mov	esi, edi
or	esi, [ebp+arg_0]
mov	[ebp+var_C], edi
and	edi, [ebp+arg_0]
and	esi, [ebp+var_10]
mov	[eax+38h], ecx
or	esi, edi
add	esi, ecx
mov	ecx, [ebp+var_4]
mov	edi, edx
shr	edi, 1Bh
mov	ebx, edx
shl	ebx, 5
or	edi, ebx
add	edi, esi
lea	ecx, [ecx+edi-70E44324h]
mov	[ebp+var_4], ecx
mov	ecx, [ebp+arg_0]
mov	esi, ecx
shr	ecx, 2
shl	esi, 1Eh
or	esi, ecx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+1Ch]
mov	edi, edx
xor	ecx, [eax+4]
or	edi, esi
and	edi, [ebp+var_C]
xor	ecx, [eax+30h]
mov	ebx, edx
and	ebx, esi
or	edi, ebx
mov	ebx, [ebp+var_4]
add	edi, ecx
mov	[ebp+arg_0], esi
mov	esi, [ebp+var_4]
shr	esi, 1Bh
shl	ebx, 5
or	esi, ebx
add	esi, edi
mov	edi, edx
shl	edi, 1Eh
shr	edx, 2
or	edi, edx
mov	[eax+3Ch], ecx
mov	ecx, [ebp+var_10]
lea	esi, [ecx+esi-70E44324h]
mov	ecx, [eax+34h]
xor	ecx, [eax+8]
mov	edx, edi
or	edx, [ebp+var_4]
xor	ecx, [eax]
and	edx, [ebp+arg_0]
xor	ecx, [eax+20h]
mov	[ebp+var_8], edi
and	edi, [ebp+var_4]
mov	ebx, esi
or	edx, edi
mov	edi, esi
shr	edi, 1Bh
add	edx, ecx
shl	ebx, 5
or	edi, ebx
mov	[eax], ecx
mov	ecx, [ebp+var_C]
add	edi, edx
lea	edi, [ecx+edi-70E44324h]
mov	ecx, [ebp+var_4]
mov	edx, ecx
mov	[ebp+var_C], edi
shl	edx, 1Eh
shr	ecx, 2
or	edx, ecx
mov	ecx, [eax+24h]
xor	ecx, [eax+0Ch]
mov	ebx, edx
xor	ecx, [eax+4]
or	ebx, esi
and	ebx, [ebp+var_8]
xor	ecx, [eax+38h]
mov	[ebp+var_4], edx
and	edx, esi
or	ebx, edx
add	ebx, ecx
mov	edx, edi
shl	edi, 5
mov	[eax+4], ecx
mov	ecx, [ebp+arg_0]
shr	edx, 1Bh
or	edx, edi
mov	edi, esi
shr	esi, 2
shl	edi, 1Eh
or	edi, esi
add	edx, ebx
lea	edx, [ecx+edx-70E44324h]
mov	ecx, [eax+3Ch]
xor	ecx, [eax+10h]
mov	esi, edi
or	esi, [ebp+var_C]
xor	ecx, [eax+8]
and	esi, [ebp+var_4]
xor	ecx, [eax+28h]
mov	[ebp+var_10], edi
and	edi, [ebp+var_C]
mov	[eax+8], ecx
or	esi, edi
add	esi, ecx
mov	ecx, [ebp+var_8]
mov	edi, edx
shr	edi, 1Bh
mov	ebx, edx
shl	ebx, 5
or	edi, ebx
add	edi, esi
lea	edi, [ecx+edi-70E44324h]
mov	ecx, [ebp+var_C]
mov	esi, ecx
shr	ecx, 2
shl	esi, 1Eh
or	esi, ecx
mov	ecx, [eax+2Ch]
xor	ecx, [eax+14h]
mov	ebx, esi
xor	ecx, [eax+0Ch]
or	ebx, edx
and	ebx, [ebp+var_10]
xor	ecx, [eax]
mov	[ebp+var_C], esi
and	esi, edx
or	ebx, esi
mov	esi, edi
mov	[ebp+var_8], edi
shl	edi, 5
shr	esi, 1Bh
or	esi, edi
add	ebx, ecx
mov	[eax+0Ch], ecx
mov	ecx, [ebp+var_4]
add	esi, ebx
lea	esi, [ecx+esi-70E44324h]
mov	ecx, [eax+10h]
xor	ecx, [eax+4]
mov	edi, edx
xor	ecx, [eax+30h]
shr	edx, 2
shl	edi, 1Eh
or	edi, edx
xor	ecx, [eax+18h]
mov	edx, [ebp+var_8]
mov	[ebp+arg_0], edi
mov	[eax+10h], ecx
mov	ebx, [ebp+var_8]
or	edx, edi
and	edx, [ebp+var_C]
and	ebx, edi
or	edx, ebx
add	edx, ecx
mov	ecx, [ebp+var_10]
mov	edi, esi
mov	ebx, esi
shl	ebx, 5
shr	edi, 1Bh
or	edi, ebx
add	edi, edx
lea	edi, [ecx+edi-70E44324h]
mov	ecx, [ebp+var_8]
mov	edx, ecx
shr	ecx, 2
shl	edx, 1Eh
or	edx, ecx
mov	ecx, [eax+34h]
xor	ecx, [eax+1Ch]
mov	ebx, edx
xor	ecx, [eax+14h]
or	ebx, esi
xor	ecx, [eax+8]
and	ebx, [ebp+arg_0]
mov	[eax+14h], ecx
mov	[ebp+var_8], edx
and	edx, esi
or	ebx, edx
add	ebx, ecx
mov	ecx, [ebp+var_C]
mov	[ebp+var_10], edi
mov	edx, edi
shl	edi, 5
shr	edx, 1Bh
or	edx, edi
add	edx, ebx
lea	edx, [ecx+edx-70E44324h]
mov	ecx, [eax+0Ch]
xor	ecx, [eax+38h]
mov	edi, esi
xor	ecx, [eax+20h]
shr	esi, 2
xor	[eax+18h], ecx
shl	edi, 1Eh
or	edi, esi
mov	ecx, edi
or	ecx, [ebp+var_10]
mov	esi, edi
and	esi, [ebp+var_10]
and	ecx, [ebp+var_8]
mov	ebx, edx
or	ecx, esi
add	ecx, [eax+18h]
shl	ebx, 5
mov	esi, edx
shr	esi, 1Bh
or	esi, ebx
add	esi, ecx
mov	ecx, [ebp+arg_0]
lea	ecx, [ecx+esi-70E44324h]
mov	[ebp+arg_0], ecx
mov	ecx, [ebp+var_10]
mov	esi, ecx
shr	ecx, 2
shl	esi, 1Eh
or	esi, ecx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+24h]
mov	ebx, esi
xor	ecx, [eax+1Ch]
or	ebx, edx
xor	ecx, [eax+10h]
mov	[ebp+var_10], esi
and	esi, edx
and	ebx, edi
or	ebx, esi
mov	esi, [ebp+arg_0]
mov	[ebp+var_4], edi
mov	[eax+1Ch], ecx
mov	edi, [ebp+arg_0]
add	ebx, ecx
mov	ecx, [ebp+var_8]
shl	edi, 5
shr	esi, 1Bh
or	esi, edi
add	esi, ebx
lea	esi, [ecx+esi-70E44324h]
mov	ecx, [eax+14h]
xor	ecx, [eax]
mov	edi, edx
xor	ecx, [eax+28h]
shr	edx, 2
xor	[eax+20h], ecx
shl	edi, 1Eh
or	edi, edx
mov	ecx, edi
or	ecx, [ebp+arg_0]
mov	edx, edi
and	ecx, [ebp+var_10]
and	edx, [ebp+arg_0]
mov	ebx, esi
or	ecx, edx
add	ecx, [eax+20h]
mov	edx, esi
shr	edx, 1Bh
shl	ebx, 5
or	edx, ebx
add	edx, ecx
mov	ecx, [ebp+var_4]
lea	ecx, [ecx+edx-70E44324h]
mov	[ebp+var_4], ecx
mov	ecx, [ebp+arg_0]
mov	edx, ecx
shr	ecx, 2
shl	edx, 1Eh
or	edx, ecx
mov	ecx, [eax+2Ch]
xor	ecx, [eax+24h]
mov	ebx, esi
xor	ecx, [eax+4]
or	ebx, edx
xor	ecx, [eax+18h]
and	ebx, edi
mov	[ebp+var_C], edi
mov	edi, esi
and	edi, edx
or	ebx, edi
mov	edi, [ebp+var_4]
add	ebx, ecx
mov	[ebp+arg_0], edx
mov	edx, [ebp+var_4]
mov	[eax+24h], ecx
mov	ecx, [ebp+var_10]
shl	edi, 5
shr	edx, 1Bh
or	edx, edi
add	edx, ebx
lea	edx, [ecx+edx-70E44324h]
mov	ecx, [eax+1Ch]
xor	ecx, [eax+8]
mov	edi, esi
xor	ecx, [eax+30h]
shr	esi, 2
xor	[eax+28h], ecx
shl	edi, 1Eh
or	edi, esi
mov	ecx, edi
or	ecx, [ebp+var_4]
mov	esi, edi
and	esi, [ebp+var_4]
and	ecx, [ebp+arg_0]
mov	ebx, edx
or	ecx, esi
add	ecx, [eax+28h]
mov	esi, edx
shr	esi, 1Bh
shl	ebx, 5
or	esi, ebx
mov	[ebp+var_8], edi
add	esi, ecx
mov	ecx, [ebp+var_C]
lea	ecx, [ecx+esi-70E44324h]
mov	[ebp+var_C], ecx
mov	ecx, [ebp+var_4]
mov	esi, ecx
shr	ecx, 2
shl	esi, 1Eh
or	esi, ecx
mov	ecx, [eax+34h]
xor	ecx, [eax+2Ch]
mov	ebx, esi
xor	ecx, [eax+0Ch]
or	ebx, edx
xor	ecx, [eax+20h]
and	ebx, edi
mov	edi, [ebp+var_C]
mov	[ebp+var_4], esi
and	esi, edx
or	ebx, esi
mov	esi, [ebp+var_C]
add	ebx, ecx
shl	edi, 5
mov	[eax+2Ch], ecx
mov	ecx, [ebp+arg_0]
shr	esi, 1Bh
or	esi, edi
add	esi, ebx
lea	esi, [ecx+esi-70E44324h]
mov	ecx, edx
shl	ecx, 1Eh
shr	edx, 2
or	ecx, edx
mov	edx, [eax+24h]
xor	edx, [eax+10h]
mov	[ebp+var_10], ecx
xor	edx, [eax+38h]
mov	edi, esi
xor	[eax+30h], edx
mov	edx, [eax+30h]
shr	edi, 1Bh
mov	ebx, esi
shl	ebx, 5
or	edi, ebx
mov	ebx, [ebp+var_4]
xor	ebx, ecx
mov	ecx, [ebp+var_C]
xor	ebx, ecx
add	edi, edx
mov	edx, [ebp+var_8]
add	ebx, edi
mov	edi, ecx
shr	ecx, 2
shl	edi, 1Eh
or	edi, ecx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+34h]
lea	edx, [edx+ebx-359D3E2Ah]
xor	ecx, [eax+14h]
mov	[ebp+var_C], edi
xor	ecx, [eax+28h]
mov	edi, edx
shr	edi, 1Bh
mov	ebx, edx
shl	ebx, 5
or	edi, ebx
mov	ebx, [ebp+var_10]
xor	ebx, [ebp+var_C]
add	edi, ecx
mov	[eax+34h], ecx
mov	ecx, [ebp+var_4]
xor	ebx, esi
add	ebx, edi
lea	edi, [ecx+ebx-359D3E2Ah]
mov	ecx, esi
shl	ecx, 1Eh
shr	esi, 2
or	ecx, esi
mov	[ebp+arg_0], ecx
mov	ecx, [eax+2Ch]
xor	ecx, [eax]
mov	[ebp+var_4], edi
xor	ecx, [eax+38h]
mov	esi, edi
xor	ecx, [eax+18h]
shl	edi, 5
mov	[eax+38h], ecx
shr	esi, 1Bh
or	esi, edi
add	esi, ecx
mov	ecx, [ebp+var_10]
mov	edi, edx
xor	edi, [ebp+var_C]
xor	edi, [ebp+arg_0]
add	edi, esi
lea	esi, [ecx+edi-359D3E2Ah]
mov	ecx, [eax+3Ch]
xor	ecx, [eax+1Ch]
mov	edi, edx
xor	ecx, [eax+4]
shr	edx, 2
xor	ecx, [eax+30h]
shl	edi, 1Eh
or	edi, edx
mov	[ebp+var_8], edi
xor	edi, [ebp+var_4]
mov	[eax+3Ch], ecx
xor	edi, [ebp+arg_0]
mov	edx, esi
shr	edx, 1Bh
mov	ebx, esi
shl	ebx, 5
or	edx, ebx
add	edx, ecx
mov	ecx, [ebp+var_C]
add	edi, edx
lea	edx, [ecx+edi-359D3E2Ah]
mov	ecx, [ebp+var_4]
mov	edi, ecx
shr	ecx, 2
shl	edi, 1Eh
or	edi, ecx
mov	ecx, [eax+34h]
xor	ecx, [eax+8]
mov	ebx, edx
xor	ecx, [eax]
mov	[ebp+var_C], edx
xor	ecx, [eax+20h]
shr	ebx, 1Bh
shl	edx, 5
or	ebx, edx
mov	edx, [ebp+var_8]
add	ebx, ecx
mov	[eax], ecx
mov	ecx, [ebp+arg_0]
xor	edx, edi
xor	edx, esi
add	edx, ebx
lea	edx, [ecx+edx-359D3E2Ah]
mov	ecx, esi
shl	ecx, 1Eh
shr	esi, 2
or	ecx, esi
mov	[ebp+var_10], ecx
mov	ecx, [eax+24h]
xor	ecx, [eax+0Ch]
mov	ebx, edx
xor	ecx, [eax+4]
shr	ebx, 1Bh
xor	ecx, [eax+38h]
mov	esi, edx
shl	esi, 5
mov	[ebp+var_4], edi
xor	edi, [ebp+var_10]
or	ebx, esi
mov	esi, [ebp+var_C]
add	ebx, ecx
xor	edi, esi
mov	[eax+4], ecx
mov	ecx, [ebp+var_8]
add	edi, ebx
lea	ebx, [ecx+edi-359D3E2Ah]
mov	[ebp+var_8], ebx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+10h]
mov	edi, esi
xor	ecx, [eax+8]
shr	esi, 2
xor	ecx, [eax+28h]
shl	edi, 1Eh
or	edi, esi
mov	esi, ebx
shl	ebx, 5
mov	[eax+8], ecx
shr	esi, 1Bh
or	esi, ebx
mov	ebx, [ebp+var_10]
add	esi, ecx
mov	ecx, [ebp+var_4]
xor	ebx, edi
xor	ebx, edx
add	ebx, esi
lea	esi, [ecx+ebx-359D3E2Ah]
mov	ecx, edx
shl	ecx, 1Eh
shr	edx, 2
or	ecx, edx
mov	[ebp+arg_0], ecx
mov	ecx, [eax+2Ch]
xor	ecx, [eax+14h]
mov	edx, esi
xor	ecx, [eax+0Ch]
shr	edx, 1Bh
xor	ecx, [eax]
mov	ebx, esi
shl	ebx, 5
or	edx, ebx
mov	ebx, [ebp+var_8]
add	edx, ecx
xor	ebx, edi
xor	ebx, [ebp+arg_0]
mov	[eax+0Ch], ecx
mov	ecx, [ebp+var_10]
add	ebx, edx
mov	[ebp+var_C], edi
lea	edi, [ecx+ebx-359D3E2Ah]
mov	ecx, [ebp+var_8]
mov	edx, ecx
shr	ecx, 2
shl	edx, 1Eh
or	edx, ecx
mov	ecx, [eax+10h]
xor	ecx, [eax+4]
mov	ebx, edi
xor	ecx, [eax+30h]
shr	ebx, 1Bh
xor	ecx, [eax+18h]
mov	[ebp+var_10], edi
mov	[ebp+var_8], edx
xor	edx, esi
xor	edx, [ebp+arg_0]
shl	edi, 5
or	ebx, edi
add	ebx, ecx
mov	[eax+10h], ecx
mov	ecx, [ebp+var_C]
add	edx, ebx
lea	edx, [ecx+edx-359D3E2Ah]
mov	ecx, [eax+34h]
xor	ecx, [eax+1Ch]
mov	edi, esi
xor	ecx, [eax+14h]
shr	esi, 2
xor	ecx, [eax+8]
shl	edi, 1Eh
or	edi, esi
mov	esi, edx
mov	ebx, edx
shl	ebx, 5
shr	esi, 1Bh
or	esi, ebx
mov	ebx, [ebp+var_8]
mov	[ebp+var_4], edi
mov	[eax+14h], ecx
xor	ebx, edi
mov	edi, [ebp+var_10]
add	esi, ecx
mov	ecx, [ebp+arg_0]
xor	ebx, edi
add	ebx, esi
lea	esi, [ecx+ebx-359D3E2Ah]
mov	ecx, edi
shl	ecx, 1Eh
shr	edi, 2
or	ecx, edi
mov	edi, [eax+0Ch]
xor	edi, [eax+38h]
mov	[ebp+var_10], ecx
xor	edi, [eax+20h]
mov	ebx, esi
xor	[eax+18h], edi
shl	ebx, 5
mov	edi, esi
shr	edi, 1Bh
or	edi, ebx
add	edi, [eax+18h]
mov	ebx, [ebp+var_4]
xor	ebx, ecx
mov	ecx, [ebp+var_8]
xor	ebx, edx
add	ebx, edi
lea	ebx, [ecx+ebx-359D3E2Ah]
mov	ecx, [eax+3Ch]
xor	ecx, [eax+24h]
mov	edi, edx
xor	ecx, [eax+1Ch]
mov	[ebp+var_8], ebx
xor	ecx, [eax+10h]
shr	edx, 2
shl	edi, 1Eh
or	edi, edx
mov	edx, ebx
shl	ebx, 5
mov	[eax+1Ch], ecx
shr	edx, 1Bh
or	edx, ebx
mov	ebx, [ebp+var_10]
add	edx, ecx
mov	ecx, [ebp+var_4]
xor	ebx, edi
xor	ebx, esi
add	ebx, edx
lea	edx, [ecx+ebx-359D3E2Ah]
mov	ecx, esi
shl	ecx, 1Eh
shr	esi, 2
or	ecx, esi
mov	[ebp+arg_0], ecx
mov	ecx, [eax+14h]
xor	ecx, [eax]
mov	esi, edx
xor	ecx, [eax+28h]
shr	esi, 1Bh
xor	[eax+20h], ecx
mov	ecx, edx
shl	ecx, 5
or	esi, ecx
mov	ecx, [ebp+var_8]
add	esi, [eax+20h]
mov	ebx, ecx
xor	ebx, edi
xor	ebx, [ebp+arg_0]
mov	[ebp+var_C], edi
mov	edi, ecx
shr	ecx, 2
shl	edi, 1Eh
or	edi, ecx
mov	ecx, [eax+2Ch]
xor	ecx, [eax+24h]
add	ebx, esi
xor	ecx, [eax+4]
mov	esi, [ebp+var_10]
xor	ecx, [eax+18h]
lea	esi, [esi+ebx-359D3E2Ah]
mov	[ebp+var_8], edi
mov	[eax+24h], ecx
mov	edi, esi
mov	ebx, esi
shl	ebx, 5
shr	edi, 1Bh
or	edi, ebx
mov	ebx, [ebp+var_8]
xor	ebx, edx
xor	ebx, [ebp+arg_0]
add	edi, ecx
mov	ecx, [ebp+var_C]
add	ebx, edi
lea	edi, [ecx+ebx-359D3E2Ah]
mov	ecx, edx
shl	ecx, 1Eh
shr	edx, 2
or	ecx, edx
mov	edx, [eax+1Ch]
xor	edx, [eax+8]
mov	[ebp+var_4], ecx
xor	edx, [eax+30h]
mov	ebx, edi
xor	[eax+28h], edx
shl	ebx, 5
mov	edx, edi
shr	edx, 1Bh
or	edx, ebx
add	edx, [eax+28h]
mov	ebx, [ebp+var_8]
xor	ebx, ecx
mov	ecx, [ebp+arg_0]
xor	ebx, esi
add	ebx, edx
lea	edx, [ecx+ebx-359D3E2Ah]
mov	ecx, [eax+34h]
xor	ecx, [eax+2Ch]
mov	ebx, esi
xor	ecx, [eax+0Ch]
shr	esi, 2
xor	ecx, [eax+20h]
shl	ebx, 1Eh
or	ebx, esi
mov	[ebp+arg_0], edx
mov	esi, edx
shl	edx, 5
shr	esi, 1Bh
or	esi, edx
mov	edx, [ebp+var_4]
add	esi, ecx
mov	[eax+2Ch], ecx
mov	ecx, [ebp+var_8]
xor	edx, ebx
xor	edx, edi
add	edx, esi
lea	edx, [ecx+edx-359D3E2Ah]
mov	ecx, [eax+24h]
xor	ecx, [eax+10h]
mov	esi, edi
xor	ecx, [eax+38h]
shr	edi, 2
xor	[eax+30h], ecx
shl	esi, 1Eh
or	esi, edi
mov	[ebp+var_10], ebx
mov	ecx, edx
shr	ecx, 1Bh
mov	edi, edx
shl	edi, 5
or	ecx, edi
add	ecx, [eax+30h]
xor	ebx, esi
xor	ebx, [ebp+arg_0]
mov	[ebp+var_C], esi
add	ebx, ecx
mov	ecx, [ebp+var_4]
lea	ebx, [ecx+ebx-359D3E2Ah]
mov	ecx, [ebp+arg_0]
mov	edi, ecx
shl	edi, 1Eh
mov	[ebp+var_4], ebx
shr	ecx, 2
or	edi, ecx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+34h]
mov	[ebp+arg_0], edi
xor	ecx, [eax+14h]
mov	edi, ebx
xor	ecx, [eax+28h]
shr	edi, 1Bh
mov	[eax+34h], ecx
shl	ebx, 5
or	edi, ebx
add	edi, ecx
mov	ecx, [ebp+var_10]
mov	ebx, edx
xor	ebx, esi
xor	ebx, [ebp+arg_0]
add	ebx, edi
lea	esi, [ecx+ebx-359D3E2Ah]
mov	ecx, [eax+2Ch]
xor	ecx, [eax]
mov	edi, edx
xor	ecx, [eax+38h]
shl	edi, 1Eh
xor	ecx, [eax+18h]
shr	edx, 2
or	edi, edx
mov	[eax+38h], ecx
mov	[ebp+var_8], edi
xor	edi, [ebp+var_4]
mov	edx, esi
xor	edi, [ebp+arg_0]
shr	edx, 1Bh
mov	ebx, esi
shl	ebx, 5
or	edx, ebx
add	edx, ecx
mov	ecx, [ebp+var_C]
add	edi, edx
lea	edi, [ecx+edi-359D3E2Ah]
mov	ecx, [ebp+var_4]
mov	edx, ecx
shr	ecx, 2
shl	edx, 1Eh
or	edx, ecx
mov	ecx, [eax+3Ch]
xor	ecx, [eax+1Ch]
mov	ebx, edi
xor	ecx, [eax+4]
mov	[ebp+var_C], edi
xor	ecx, [eax+30h]
shl	edi, 5
mov	[eax+3Ch], ecx
shr	ebx, 1Bh
or	ebx, edi
mov	edi, [ebp+var_8]
add	ebx, ecx
mov	ecx, [ebp+arg_0]
xor	edi, edx
xor	edi, esi
add	edi, ebx
lea	edi, [ecx+edi-359D3E2Ah]
mov	ecx, [eax+40h]
add	ecx, edi
mov	edi, [ebp+var_C]
mov	[eax+40h], ecx
mov	ecx, [eax+44h]
add	ecx, edi
mov	[eax+44h], ecx
mov	ecx, esi
shl	ecx, 1Eh
shr	esi, 2
or	ecx, esi
add	ecx, [eax+48h]
mov	[eax+48h], ecx
mov	ecx, [eax+4Ch]
add	ecx, edx
mov	edx, [ebp+var_8]
mov	[eax+4Ch], ecx
mov	ecx, [eax+50h]
add	ecx, edx
mov	[eax+50h], ecx
pop	edi
pop	esi
pop	ebx
leave
retn
_SHA1 endp

ends

end start